{
    "$graph": [
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "ScatterFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "id": "#main/aligned_dir_name"
                },
                {
                    "type": "string",
                    "id": "#main/gs_dir_name"
                },
                {
                    "type": "Directory",
                    "id": "#main/in_dir"
                },
                {
                    "type": "string",
                    "id": "#main/ocr_dir_name"
                }
            ],
            "steps": [
                {
                    "run": "#icdar2017st-extract-text.cwl",
                    "in": [
                        {
                            "source": "#main/ls-3/out_files",
                            "id": "#main/icdar2017st-extract-text/in_file"
                        }
                    ],
                    "out": [
                        "#main/icdar2017st-extract-text/aligned",
                        "#main/icdar2017st-extract-text/gs",
                        "#main/icdar2017st-extract-text/ocr"
                    ],
                    "scatter": [
                        "#main/icdar2017st-extract-text/in_file"
                    ],
                    "scatterMethod": "dotproduct",
                    "id": "#main/icdar2017st-extract-text"
                },
                {
                    "run": "#ls.cwl",
                    "in": [
                        {
                            "source": "#main/in_dir",
                            "id": "#main/ls-3/in_dir"
                        }
                    ],
                    "out": [
                        "#main/ls-3/out_files"
                    ],
                    "id": "#main/ls-3"
                },
                {
                    "run": "#save-files-to-dir.cwl",
                    "in": [
                        {
                            "source": "#main/gs_dir_name",
                            "id": "#main/save-files-to-dir-6/dir_name"
                        },
                        {
                            "source": "#main/icdar2017st-extract-text/gs",
                            "id": "#main/save-files-to-dir-6/in_files"
                        }
                    ],
                    "out": [
                        "#main/save-files-to-dir-6/out"
                    ],
                    "id": "#main/save-files-to-dir-6"
                },
                {
                    "run": "#save-files-to-dir.cwl",
                    "in": [
                        {
                            "source": "#main/ocr_dir_name",
                            "id": "#main/save-files-to-dir-7/dir_name"
                        },
                        {
                            "source": "#main/icdar2017st-extract-text/ocr",
                            "id": "#main/save-files-to-dir-7/in_files"
                        }
                    ],
                    "out": [
                        "#main/save-files-to-dir-7/out"
                    ],
                    "id": "#main/save-files-to-dir-7"
                },
                {
                    "run": "#save-files-to-dir.cwl",
                    "in": [
                        {
                            "source": "#main/aligned_dir_name",
                            "id": "#main/save-files-to-dir-8/dir_name"
                        },
                        {
                            "source": "#main/icdar2017st-extract-text/aligned",
                            "id": "#main/save-files-to-dir-8/in_files"
                        }
                    ],
                    "out": [
                        "#main/save-files-to-dir-8/out"
                    ],
                    "id": "#main/save-files-to-dir-8"
                }
            ],
            "id": "#main",
            "outputs": [
                {
                    "type": "Directory",
                    "outputSource": "#main/save-files-to-dir-8/out",
                    "id": "#main/aligned_dir"
                },
                {
                    "type": "Directory",
                    "outputSource": "#main/save-files-to-dir-6/out",
                    "id": "#main/gs_dir"
                },
                {
                    "type": "Directory",
                    "outputSource": "#main/save-files-to-dir-7/out",
                    "id": "#main/ocr_dir"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "python",
                "-m",
                "ochre.icdar2017st_extract_text"
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#icdar2017st-extract-text.cwl/in_file"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.json"
                    },
                    "id": "#icdar2017st-extract-text.cwl/aligned"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "gs/*.txt"
                    },
                    "id": "#icdar2017st-extract-text.cwl/gs"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "ocr/*.txt"
                    },
                    "id": "#icdar2017st-extract-text.cwl/ocr"
                }
            ],
            "id": "#icdar2017st-extract-text.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "python",
                "-m",
                "nlppln.commands.ls"
            ],
            "doc": "List files in a directory.\n\nThis command can be used to convert a ``Directory`` into a list of files. This list can be filtered on file name by specifying ``--endswith``.\n",
            "inputs": [
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "--endswith"
                    },
                    "id": "#ls.cwl/endswith"
                },
                {
                    "type": "Directory",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#ls.cwl/in_dir"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "--recursive"
                    },
                    "id": "#ls.cwl/recursive"
                }
            ],
            "stdout": "cwl.output.json",
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#ls.cwl/out_files"
                }
            ],
            "id": "#ls.cwl"
        },
        {
            "class": "ExpressionTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "doc": "Save a list of files to a directory.\n",
            "inputs": [
                {
                    "type": "string",
                    "id": "#save-files-to-dir.cwl/dir_name"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#save-files-to-dir.cwl/in_files"
                }
            ],
            "outputs": [
                {
                    "type": "Directory",
                    "id": "#save-files-to-dir.cwl/out"
                }
            ],
            "expression": "${\n  return {\"out\": {\n    \"class\": \"Directory\",\n    \"basename\": inputs.dir_name,\n    \"listing\": inputs.in_files\n  } };\n}\n",
            "id": "#save-files-to-dir.cwl"
        }
    ],
    "cwlVersion": "v1.0"
}
